      PROGRAM CPA
      IMPLICIT REAL*8 (A-H,O-Z)
C THIS IS THE MAIN PROGRAM
C     THIS PROGRAM HAS THE SEEDS OF FAULKNER'S PDH CODE
CWRITTEN BY BOYER,KLEIN,PAPACONSTANTOPOULOS
C     Modified by Papaconstantopoulos to use two-center tight
C     binding parameters. 
C     TREATS VACANCIES ON THE NON-METAL SITE
C     NO DISORDER ON THE METAL SITE
      COMMON/ADDIN/ WEIGHT,TOTVOL
      DIMENSION GR11(1500),GI11(1500),GR22(1500),GI22(1500)
      DIMENSION WEIGHT(1500),QQ(1500,3)
      DIMENSION H(9,9),UPARM(51),X(9,9),V(9,4)
      DIMENSION A(20)
      DIMENSION QR(4,4),QI(4,4),AR(1500,4,4),AI(1500,4,4),BMAT(4,4),
     $ GR(4,4),GI(4,4),SIGR(4),SIGI(4)
      DIMENSION HMZ(9,9,1500),VST(9,4,1500),BKMAT(4,4,1500)
      DIMENSION RES(4000,16)
      DIMENSION XR(50,9,9),XI(50,9,9),YR(50,9,9),YI(50,9,9),ZR(50,9,9),
     $ ZI(50,9,9)
      DIMENSION ANUMEL(4000),DUMM(4000),EDUM(4000),DUMP2(4000)
      DIMENSION DUMS1(4000),DUMP1(4000),DUMD1(4000),DUMD2(4000)
      DIMENSION DENSFL(6),DUMS2(4000)
      REAL*8 INTERP
      REAL*8 NUELEC
      OPEN(5,FILE='cpa.in',BLANK='ZERO')
      OPEN(6,FILE='cpa.out',BLANK='ZERO')
      OPEN(25,FILE='cpa.dos',BLANK='ZERO')
 1000 FORMAT(4I5,F10.5)
 1001 FORMAT(F13.10)
C1001 FORMAT(8F10.4)
 1002 FORMAT(I5,3F10.5)
 1003 FORMAT(6D15.5)
 1004 FORMAT(5F10.4/4F10.4,I5)
 1006 FORMAT(10X,F15.8,I10)
 2002 FORMAT(20A4)
 9000 FORMAT(1H1)
      PI= 3.1415926536
      PP= 1./PI
      NUMIT= 100
      CONV=1.0E-4
      READ(5,2002)(A(I),I=1,20)
      WRITE(6,2002)(A(I),I=1,20)
      READ (5,1000)NPARM,NDIM,NINI,NFIN,NUELEC
      WRITE(6,1000)NPARM,NDIM,NINI,NFIN,NUELEC
      DO 8600  J=1,NPARM
      READ (5,1040)UPARM(J),NNP
      WRITE(6,1006)UPARM(J),NNP
 1040 FORMAT(F13.10,4X,I3)
      IF(NNP.EQ.J) GO TO 8600
      PRINT 1045
 1045 FORMAT(//10X,42H PARAMETER CARDS OUT OF ORDER --- STOPPING)
      STOP
 8600 CONTINUE
      READ(5,1004)CB,EMIN,EMAX,DELE,EPIV,SAGSR1,SAGSI1,SAGPR1,SAGPI1,NCHK
      WRITE(6,9000)
      WRITE(6,1004)
     $         CB,EMIN,EMAX,DELE,EPIV,SAGSR1,SAGSI1,SAGPR1,SAGPI1,NCHK
      READ (5,8700)EPS
      WRITE(6,8710)EPS
 8700 FORMAT(F15.6)
 8710 FORMAT(//,15X,' EPS= ',F15.6,//)
      CALL BZONE(NINI,QQ,NUMINI)
      MF2= 2*NINI
      MF21= 2*NINI + 1
      WRITE(6,8500) NINI,NUMINI,NFIN,NUMFIN
 8500 FORMAT(///,20X,'INITIAL MESH= ',I5,10X,I7,'  POINTS',//)
      CALL WTFIND(NINI,MF21)
      NS= NUMINI
      N50= NS/50 + 1
      M50= 50*(N50 - 1)
      DO 8580  I=1,NS
      XK1=QQ(I,1)
      XK2=QQ(I,2)
      XK3=QQ(I,3)
      CALL MATS(XK1,XK2,XK3,H,UPARM,V,NDIM,BMAT)
      DO 8570  J=1,NDIM
      DO 8575  LL=1,4
      VST(J,LL,I)= V(J,LL)
 8575 CONTINUE
      DO 8570  K=1,NDIM
      HMZ(J,K,I)= H(J,K)
 8570 CONTINUE
C      WRITE(30,4222) I,XK1,XK2,XK3
 4222  FORMAT (5X,I5,3X,F10.5,3X,F10.5,3X,F10.5)
C      WRITE(30,4218) ((H(K1,K2),K1=1,9),K2=1,9)
      DO 8560  LL=1,4
      DO 8560  MM=1,4
      BKMAT(LL,MM,I)= BMAT(LL,MM)
 8560 CONTINUE
 8580 CONTINUE
      ISS1= 1
      EHS= UPARM(25)
      EHP= UPARM(26)
 1111 IF(NCHK.EQ.2)GOTO1234
      SAGSR= SAGSR1
      SAGSI= SAGSI1
      SAGPR= SAGPR1
      SAGPI= SAGPI1
C     WRITE(30,7789)
 7789 FORMAT(20X,'FINISHED WITH H',///)
      IF(NCHK.EQ.0)NMODE=1
      IF(NCHK.EQ.1)NMODE=2
      IF(NCHK.EQ.1)EPIV= EPIV - DELE
      E=EPIV
      DO 9999  IXYZ=ISS1,500
      DO 800  I1=1,N50
      J50= (I1-1)*50
      I50= 50
      IF((I1*50).GT.NS) I50= NS - M50
      IF( I50.LE.0) GO TO 800
      DO 810  I2=1,I50
      I= J50 + I2
      DO7K=1,NDIM
      DO7L=1,NDIM
      IF(K.EQ.L)GOTO79
      XR(I2,K,L)= HMZ(K,L,I)
      XI(I2,K,L)= 0.0
      YR(I2,K,L)= 0.0
      YI(I2,K,L)= 0.0
      GOTO7
   79 XR(I2,K,K)= HMZ(K,K,I) - E
      XI(I2,K,K)= - EPS
      YR(I2,K,K)= 1.0
      YI(I2,K,K)= 0.0
 7    CONTINUE
C      WRITE(30,7778)
C      WRITE(30,4218) ((XR(I2,K1,K2),K1=1,9),K2=1,9)
 4218  FORMAT(3X,9F12.5)
C      WRITE(30,7779)
C      WRITE(30,4218) ((XI(I2,K1,K2),K1=1,9),K2=1,9)
  810 CONTINUE
      CALL CLSS(9,9,XR,XI,9,YR,YI,9,I50)
      DO 9  I2=1,I50
C      WRITE(30,7768)
C      WRITE(30,4218) ((YR(I2,K1,K2),K1=1,9),K2=1,9)
C      WRITE(30,7767)
 7767  FORMAT(20X,'IMAGINARY PART OF Y')
 7779  FORMAT(20X,'IMAGINARY PART OF X')
 7768 FORMAT(20X,'REAL PART OF Y')
 7778 FORMAT(20X,'REAL PART OF X')
C      WRITE(30,4218) ((YI(I2,K1,K2),K1=1,9),K2=1,9)
      I= J50 + I2
      DO 80  J1=1,4
      DO 80  J2=1,J1
      QR(J1,J2)= 0.0
      QI(J1,J2)= 0.0
      DO77K=1,NDIM
      DO77L=1,NDIM
      QR(J1,J2)= QR(J1,J2)+ VST(K,J1,I)*YR(I2,K,L)*VST(L,J2,I)
      QI(J1,J2)= QI(J1,J2)+ VST(K,J1,I)*YI(I2,K,L)*VST(L,J2,I)
   77 CONTINUE
      TEMP1=0.0
      TEMP2=0.0
      IF(J1.NE.J2) GO TO 81
      TEMP1= E
      TEMP2= EPS
   81 AR(I,J1,J2)=   QR(J1,J2)   +TEMP1 - BKMAT(J1,J2,I)
      AI(I,J1,J2)= QI(J1,J2)      + TEMP2
      AR(I,J2,J1)= AR(I,J1,J2)
      AI(I,J2,J1)= AI(I,J1,J2)
   80 CONTINUE
    9 CONTINUE
  800 CONTINUE
      SIGSR= SAGSR
      SIGSI= SAGSI
      SIGPR= SAGPR
      SIGPI= SAGPI
      SIGR(1)= SIGSR
      SIGI(1)= SIGSI
      SIGR(2)= SIGPR
      SIGR(3)= SIGPR
      SIGR(4)= SIGPR
      SIGI(2)= SIGPI
      SIGI(3)= SIGPI
      SIGI(4)= SIGPI
      DO999N=1,NUMIT
      WRITE(6,1210)N,SIGSR,SIGSI,SIGPR,SIGPI
 1210 FORMAT(2X,I5,2F10.5,2F10.5)
      MCHK=0
      DO 2020  L=1,4
      DO 2020  M=1,4
      GR(L,M)= 0.0
      GI(L,M)= 0.0
 2020 CONTINUE
      DO 820  I1=1,N50
      J50= (I1-1)*50
      I50= 50
      IF((I1*50).GT.NS) I50= NS - M50
      IF( I50.LE.0) GO TO 820
      DO 830  I2=1,I50
      I= J50 + I2
      DO 2000  L=1,4
      DO 2000  M=1,4
      XR(I2,L,M)= AR(I,L,M)
      XI(I2,L,M)= AI(I,L,M)
      YR(I2,L,M)= 0.0
      YI(I2,L,M)= 0.0
      IF(L.EQ.M) YR(I2,L,M)= 1.0
 2000 CONTINUE
      DO 835  I4=1,4
      XR(I2,I4,I4)= XR(I2,I4,I4) - SIGR(I4)
      XI(I2,I4,I4)= XI(I2,I4,I4) - SIGI(I4)
  835 CONTINUE
  830 CONTINUE
      CALL CLSS(4,4,XR,XI,4,YR,YI,4,I50)
      DO 99  I2=1,I50
C     DO 8115 L4 =1,4
C     DO 8115 L5 = 1,4
C     PRINT8116, YR(I2,L4,L5),I2,L4,L5
C8115 PRINT8116, YI(I2,L4,L5),I2,L4,L5
 8116 FORMAT(10X,E15.5,5X,I5,5X,I5,5X,I5)
      I= J50 + I2
      GR11(I)= YR(I2,1,1)
      GI11(I)= YI(I2,1,1)
      GR22(I)= (YR(I2,2,2) + YR(I2,3,3) + YR(I2,4,4))/3.0
      GI22(I)= (YI(I2,2,2) + YI(I2,3,3) + YI(I2,4,4))/3.0
   99 CONTINUE
  820 CONTINUE
      DO 1230  I=1,NUMINI
      GR(1,1)= GR(1,1) + GR11(I)*WEIGHT(I)
      GI(1,1)= GI(1,1) + GI11(I)*WEIGHT(I)
      GR(2,2)= GR(2,2) + GR22(I)*WEIGHT(I)
      GI(2,2)= GI(2,2) + GI22(I)*WEIGHT(I)
 1230 CONTINUE
      GR(1,1)= GR(1,1)/TOTVOL
      GI(1,1)= GI(1,1)/TOTVOL
      GR(2,2)= GR(2,2)/TOTVOL
      GI(2,2)= GI(2,2)/TOTVOL
C     PRINT 7003, GR(1,1),GI(1,1),GR(2,2),GI(2,2)
 7003 FORMAT(5X,4F16.5)
      G1= GR(1,1)**2 + GI(1,1)**2
      G2= GR(2,2)**2 + GI(2,2)**2
      DELSR= - SIGSR + EHS - CB*GR(1,1)/G1
      DELSI= -SIGSI + CB*GI(1,1)/G1
      DELPR= -SIGPR + EHP - CB*GR(2,2)/G2
      DELPI= -SIGPI + CB*GI(2,2)/G2
C     PRINT 7775, DELSR,DELPR,DELSI,DELPI
 7775 FORMAT(5X,'DELSR = ',F11.5,5X,'DELPR= ',F11.5,5X,'DELSI = ',F11.5
     ,,5X,'DELPI = ',F11.5)
      IF(ABS(DELSR).LT.CONV.AND.ABS(DELSI).LT.CONV.AND.ABS(DELPR).LT.
     $ CONV.AND.ABS(DELPI).LT.CONV) MCHK=1
      SIGSR= DELSR + SIGSR
      SIGSI= DELSI + SIGSI
      SIGPR= DELPR + SIGPR
      SIGPI= DELPI + SIGPI
      SAGSR= SIGSR
      SAGSI= SIGSI
      SAGPR= SIGPR
      SAGPI= SIGPI
      SIGR(1)= SIGSR
      SIGI(1)= SIGSI
      SIGR(2)= SIGPR
      SIGR(3)= SIGPR
      SIGR(4)= SIGPR
      SIGI(2)= SIGPI
      SIGI(3)= SIGPI
      SIGI(4)= SIGPI
      IF(MCHK.EQ.1)GOTO9991
 999  CONTINUE
      WRITE(6,5004)E
 5004 FORMAT('   SIGMA DIDN T CONVERGE FOR E=',F10.4)
      NCHK=NCHK+1
      GOTO1111
 9991 CONTINUE
      WRITE(6,1015)N,SIGSR,SIGSI,SIGPR,SIGPI,E
 1015 FORMAT(5X,I5,4F15.8,F10.3)
      GPDS= 0.0
      GPDP= 0.0
      GPDTG= 0.0
      GPDEG= 0.0
      DO 860  I1=1,N50
      J50= (I1-1)*50
      I50= 50
      IF((I1*50).GT.NS) I50= NS - M50
      IF( I50.LE.0) GO TO 860
      DO 870  I2=1,I50
      I= J50 + I2
      DO 87  L=1,4
      DO 87  M=1,4
      YI(I2,L,M) =0.0
      IF(L.EQ.M) GO TO 875
      XR(I2,L,M)= BKMAT(L,M,I)
      XI(I2,L,M)= 0.0
      YR(I2,L,M)= 0.0
      GO TO 87
  875 XR(I2,L,L)= BKMAT(L,L,I) + SIGR(L)      - E
      XI(I2,L,L)=    SIGI(L)    - EPS
      YR(I2,L,L)= 1.0
   87 CONTINUE
  870 CONTINUE
      CALL CLSS(4,4,XR,XI,4,YR,YI,4,I50)
      DO 880  I2=1,I50
      I= J50 + I2
      DO 88  J=1,NDIM
      DO 88  K=1,NDIM
      XR(I2,J,K)= - HMZ(J,K,I)
      XI(I2,J,K)=0.0
      DO 89  L=1,4
      DO 89  M=1,4
      UR1= YR(I2,L,M)
      UI1= YI(I2,L,M)
      XR(I2,J,K)= XR(I2,J,K) + VST(J,L,I)*UR1*VST(K,M,I)
      XI(I2,J,K)= XI(I2,J,K) + VST(J,L,I)*UI1*VST(K,M,I)
   89 CONTINUE
      ZI(I2,J,K)= 0.0
      IF(J.EQ.K) GO TO 885
      ZR(I2,J,K)= 0.0
      GO TO 88
  885 XR(I2,J,K)= XR(I2,J,K) + E
      XI(I2,J,K)= XI(I2,J,K) + EPS
      ZR(I2,J,K)= 1.0
   88 CONTINUE
  880 CONTINUE
      CALL CLSS(9,9,XR,XI,9,ZR,ZI,9,I50)
      DO 8  I2=1,I50
      I= J50 + I2
      GR11(I)= ZI(I2,1,1)
      GI11(I)= (ZI(I2,2,2)+ZI(I2,3,3)+ZI(I2,4,4))
      GR22(I)= (ZI(I2,5,5)+ZI(I2,6,6)+ZI(I2,7,7))
      GI22(I)= (ZI(I2,8,8)+ZI(I2,9,9))
    8 CONTINUE
  860 CONTINUE
      DO 890  I=1,NUMINI
      GPDS= GPDS + GR11(I)*WEIGHT(I)
      GPDP= GPDP + GI11(I)*WEIGHT(I)
      GPDTG= GPDTG + GR22(I)*WEIGHT(I)
      GPDEG= GPDEG + GI22(I)*WEIGHT(I)
  890 CONTINUE
      GPDS= GPDS/TOTVOL
      GPDP= GPDP/TOTVOL
      GPDTG= GPDTG/TOTVOL
      GPDEG= GPDEG/TOTVOL
      ROPDS= -PP*GPDS
      ROPDP= -PP*GPDP
      ROPDTG= -PP*GPDTG
      ROPDEG= -PP*GPDEG
      ROPDD= ROPDTG+ ROPDEG
      ROPD= ROPDS+ ROPDP+ ROPDD
      ROHS= -PP*GI(1,1)
      ROHP= -PP*3.0*GI(2,2)
      ROH= ROHS+ ROHP
      ROTOT= ROPD+ ROH
      RES(IXYZ,1)=E
      RES(IXYZ,2)= SIGSR
      RES(IXYZ,3)= SIGSI
      RES(IXYZ,4)= SIGPR
      RES(IXYZ,5)= SIGPI
      RES(IXYZ,6)= ROPDS
      RES(IXYZ,7)= ROPDP
      RES(IXYZ,8)= ROPDEG
      RES(IXYZ,9)= ROPDTG
      RES(IXYZ,10)= ROPDD
      RES(IXYZ,11)= ROPD
      RES(IXYZ,12)= ROHS
      RES(IXYZ,13)= ROHP
      RES(IXYZ,14)= ROH
      RES(IXYZ,15)= ROTOT
      WRITE(6,1030)E,SIGSR,SIGSI,SIGPR,SIGPI,ROPDS,ROPDP,ROPDEG,ROPDTG,
     1ROPDD,ROPD,ROHS,ROHP,ROH,ROTOT
 1030 FORMAT(//1X,F6.3,4F8.4,///10X,10F10.5//)
      IF(NMODE.EQ.2)GOTO51
      E=E+DELE
      IF(E.LE.EMAX)GOTO9999
      ISS= IXYZ
      ISS1= ISS + 1
      NCHK=NCHK+1
      GOTO1111
 51   E=E-DELE
      IF(E.GE.EMIN)GOTO9999
      GOTO1234
 9999 CONTINUE
 1234 CONTINUE
      ITOP= IXYZ
      WRITE(6,3000)
 3000 FORMAT(1H1,///)
      WRITE(6,3010)
 3010 FORMAT(20X,' PRINTING OF --- ENERGY --COMPLEX SIGS  ---- COMPLEX
     $ SIGP'///)
      L= ITOP + 1
      L9= 0
      DO 3020  LL=ISS1,ITOP
      L= L - 1
      L9= L9 + 1
      DUMM(L9)= RES(L,15)*2.0
      EDUM(L9)= RES(L,1)
      DUMS1(L9)=RES(L,6)*2.0
      DUMP1(L9)=RES(L,7)*2.0
      DUMD1(L9)=RES(L,9)*2.0
      DUMD2(L9)=RES(L,8)*2.0
      DUMS2(L9)=RES(L,12)*2.0
      DUMP2(L9)=RES(L,13)*2.0
      WRITE(6,3030)(RES(L,M),M=1,5)
C     PUNCH 4000,(RES(L,M),M=1,5)
 3030 FORMAT(24X,F10.4,4F15.8)
 4000 FORMAT(5E15.8)
 3020 CONTINUE
      DO 3040  L=1,ISS
      L9= L9 + 1
      DUMM(L9)= RES(L,15)*2.0
      EDUM(L9)= RES(L,1)
      DUMS1(L9)=RES(L,6)*2.0
      DUMP1(L9)=RES(L,7)*2.0
      DUMD1(L9)=RES(L,9)*2.0
      DUMD2(L9)=RES(L,8)*2.0
      DUMS2(L9)=RES(L,12)*2.0
      DUMP2(L9)=RES(L,13)*2.0
      WRITE(6,3030)(RES(L,M),M=1,5)
C     PUNCH 4000,(RES(L,M),M=1,5)
 3040 CONTINUE
      NUM99= ITOP-1
      CALL SIMP(EDUM,DUMM,ANUMEL,NUM99)
      ANUMEL(1)= 0.0
      ANUMEL(ITOP)= ANUMEL(NUM99) + RES(ISS,15)*DELE*2.0
      WRITE(6,3000)
      WRITE(6,3050)
 3050 FORMAT(10X,'PDS,PDP,PDEG,PDTG,PDD,PDTOT,HS,HP,HTOT,TOT-DOS,NUMEL'
     $ ///)
      L= ITOP + 1
      L9= 0
      DO 3060  LL=ISS1,ITOP
      L= L - 1
      L9= L9 + 1
      RES(L,16)= ANUMEL(L9)
      WRITE(6,3070)RES(L,1),(RES(L,M),M=6,16)
      WRITE(25,3077) (RES(L,M),M=1,16)
 3077 FORMAT(4(4E20.8/))
 3070 FORMAT(4X,12F10.4)
 4010 FORMAT(F6.3,8F9.5)
 3060 CONTINUE
      DO 3080  L=1,ISS
      L9= L9 + 1
      RES(L,16)= ANUMEL(L9)
      WRITE(6,3070)RES(L,1),(RES(L,M),M=6,16)
      WRITE(25,3077) (RES(L,M),M=1,16)
 3080 CONTINUE
      MCOUNT=0
      DO 4080 L=1,ITOP
      IF(ANUMEL(L).GT.NUELEC) GO TO 178
      GO TO 4080
  178 IF(MCOUNT .NE. 0) GO TO 4080
      MCOUNT=L
 4080 CONTINUE
C     LINEAR     INTERPOLATION OF THE FERMI LEVEL
      MC=MCOUNT
      MCM=MC-1
      S=NUELEC
      EFL=INTERP(S,ANUMEL   ,EDUM(1) ,MCM,2)
      DNORFL=INTERP(S,ANUMEL   ,DUMM(1)  ,MCM,2)/2.0
      WRITE(6,841)
  841 FORMAT(//65X,11H (PER SPIN)  )
      DENSFL(1)=INTERP(S,ANUMEL   ,DUMS1(1),MCM,2)/2.0
      DENSFL(2)=INTERP(S,ANUMEL   ,DUMP1(1),MCM,2)/2.0
      DENSFL(3)=INTERP(S,ANUMEL   ,DUMD1(1),MCM,2)/2.0
      DENSFL(4)=INTERP(S, ANUMEL  ,DUMD2(1),MCM,2)/2.0
      DENSFL(5)=INTERP(S,ANUMEL   ,DUMS2(1) ,MCM,2)/2.0
      DENSFL(6)=INTERP(S,ANUMEL   ,DUMP2(1) ,MCM,2)/2.0
      WRITE(6,193)
  193 FORMAT(9X,6HENERGY,7X,9HELECTRONS,6X,9HTOTAL DOS,11X,1HS,14X,1HP,
     1 14X,4HDT2G,14X,3HDEG  //)
      WRITE(6,839) EFL,NUELEC,DNORFL,(DENSFL(I),I=1,6)
  839  FORMAT(2F10.5   ,3X,7F10.5//)
      STOP
      END
      SUBROUTINE BZONE(N,Q,NUM)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION Q(1500,3)
C   NSWIT=1   FCC
C   NSWIT=2   SIMPLE CUBIC
       NSWIT=1
      NUM= 0
      IM= 2*N + 1
      NN= 2*N
      FNN = FLOAT(NN)
      DO 10  I=1,IM
      DO 10  J=1,I
      DO 10  K=1,J
      IT= I+J+K-3
      IF(NSWIT.EQ.2) GO TO 66
      IF(N*3.LT.IT) GO TO 10
   66 CONTINUE
      NUM= NUM + 1
C     IF(NSWIT.EQ.1)   M35(NUM)= I*(I-1)*(I+1)/6 + J*(J-1)/2 + K
      Q(NUM,1)=FLOAT(I-1)/FNN
      Q(NUM,2)= FLOAT(J-1)/FNN
      Q(NUM,3)= FLOAT(K-1)/FNN
   10 CONTINUE
      RETURN
      END
      SUBROUTINE CLSS(N,M,AR,AI,IA,BR,BI,IB,NMAT)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AR(50,9,9),AI(50,9,9),BR(50,9,9),BI(50,9,9),X(50),T(50)
      DIMENSION L(50),SR1(50),SI1(50),SR2(50),SI2(50),VR(50),VI(50)
      DIMENSION HR(50),HI(50)
      ID=1
      IF(N.GT.IA.OR.N.GT.IB.OR.N.LE.0.OR.M.LE.0) GO TO 17
      DO 11 I=1,N
      IM1=I-1
      DO 110 II=1,NMAT
      TT=AR(II,I,I)**2+AI(II,I,I)**2
      T(II)=SQRT(TT)
  110 CONTINUE
      IF(I.EQ.N) GO TO 130
      DO 109 II=1,NMAT
  109 L(II)=I
      IP1=I+1
      DO 1 J=IP1,N
      DO 111 II=1,NMAT
      XX=AR(II,J,I)**2+AI(II,J,I)**2
      X(II)=SQRT(XX)
      IF(X(II).LE.T(II)) GO TO 111
      T(II)=X(II)
      L(II)=J
  111 CONTINUE
    1 CONTINUE
      DO 112 II=1,NMAT
      IF(T(II).EQ.0.0) GO TO 15
      IF(T(II).LT.1.0E-15) WRITE(6,80)
  112 CONTINUE
   80 FORMAT('  SYSTEM NEAR SINGULAR --- CALCULATION CONTINUING')
      DO 113 II=1,NMAT
      LL=L(II)
      IF(LL.EQ.I) GO TO 4
      DO 2 J=1,N
      TEMPR=AR(II,I,J)
      TEMPI=AI(II,I,J)
      AR(II,I,J)=AR(II,LL,J)
      AI(II,I,J)=AI(II,LL,J)
      AR(II,LL,J)=TEMPR
      AI(II,LL,J)=TEMPI
    2 CONTINUE
      DO 3 J=1,M
      TEMPR=BR(II,I,J)
      TEMPI=BI(II,I,J)
      BR(II,I,J)=BR(II,LL,J)
      BI(II,I,J)=BI(II,LL,J)
      BR(II,LL,J)=TEMPR
      BI(II,LL,J)=TEMPI
    3 CONTINUE
    4 CONTINUE
  113 CONTINUE
  130 CONTINUE
      DO 114 II=1,NMAT
      SR1(II)=AR(II,I,I)**2+AI(II,I,I)**2
  114 CONTINUE
      DO 115 II=1,NMAT
      VR(II)=AR(II,I,I)/SR1(II)
      VI(II)=AI(II,I,I)/SR1(II)
  115 CONTINUE
      IF(I.EQ.N) GO TO 9
      DO 8 J=IP1,N
      DO 116 II=1,NMAT
      SR1(II)=0.0
      SI1(II)=0.0
      SR2(II)=0.0
      SI2(II)=0.0
  116 CONTINUE
      IF(IM1.EQ.0) GO TO 6
      DO 5 K=1,IM1
      DO 5 II=1,NMAT
      SR1(II)=SR1(II)+AR(II,I,K)*AR(II,K,J)-AI(II,I,K)*AI(II,K,J)
      SI1(II)=SI1(II)+AR(II,I,K)*AI(II,K,J)+AR(II,K,J)*AI(II,I,K)
    5 CONTINUE
    6 CONTINUE
      DO 117 II=1,NMAT
      HR(II)=AR(II,I,J)-SR1(II)
      HI(II)=AI(II,I,J)-SI1(II)
  117 CONTINUE
      DO 118 II=1,NMAT
      AR(II,I,J)=HR(II)*VR(II)+HI(II)*VI(II)
      AI(II,I,J)=HI(II)*VR(II)-HR(II)*VI(II)
  118 CONTINUE
      DO 7 K=1,I
      DO 7 II=1,NMAT
      SR2(II)=SR2(II)+AR(II,J,K)*AR(II,K,IP1)-AI(II,J,K)*AI(II,K,IP1)
      SI2(II)=SI2(II)+AR(II,J,K)*AI(II,K,IP1)+AI(II,J,K)*AR(II,K,IP1)
    7 CONTINUE
      DO 119 II=1,NMAT
      AR(II,J,IP1) = AR(II,J,IP1)-SR2(II)
      AI(II,J,IP1) = AI(II,J,IP1)-SI2(II)
  119 CONTINUE
    8 CONTINUE
    9 CONTINUE
      DO 120 II=1,NMAT
      IF(T(II).EQ.0.0) GO TO 15
  120 CONTINUE
      DO 11 J=1,M
      DO 121 II=1,NMAT
      SR1(II)=0.0
  121 SI1(II)=0.0
      IF(IM1.EQ.0) GO TO 21
      DO 10 K=1,IM1
      DO 10 II=1,NMAT
      SR1(II)=SR1(II)+AR(II,I,K)*BR(II,K,J)-AI(II,I,K)*BI(II,K,J)
      SI1(II)=SI1(II)+AI(II,I,K)*BR(II,K,J)+AR(II,I,K)*BI(II,K,J)
   10 CONTINUE
   21 CONTINUE
      DO 122 II=1,NMAT
      HR(II)=BR(II,I,J)-SR1(II)
      HI(II)=BI(II,I,J)-SI1(II)
  122 CONTINUE
      DO 123 II=1,NMAT
      BR(II,I,J)=HR(II)*VR(II)+HI(II)*VI(II)
      BI(II,I,J)=HI(II)*VR(II)-HR(II)*VI(II)
  123 CONTINUE
   11 CONTINUE
      IF(N.EQ.1) RETURN
      NM1=N-1
      DO 13 I=1,M
      DO 13 J=1,NM1
      NMJ=N-J
      DO 124 II=1,NMAT
      SR1(II)=0.0
  124 SI1(II)=0.0
      NMJP1=NMJ+1
      DO 12 K=NMJP1,N
      DO 12 II=1,NMAT
      SR1(II)=SR1(II)+AR(II,NMJ,K)*BR(II,K,I)-AI(II,NMJ,K)*BI(II,K,I)
      SI1(II)=SI1(II)+AR(II,NMJ,K)*BI(II,K,I)+AI(II,NMJ,K)*BR(II,K,I)
   12 CONTINUE
      DO 125 II=1,NMAT
      BR(II,NMJ,I)=BR(II,NMJ,I)-SR1(II)
      BI(II,NMJ,I)=BI(II,NMJ,I)-SI1(II)
  125 CONTINUE
   13 CONTINUE
      RETURN
   15 ID=2
   17 WRITE(6,85)
   85 FORMAT(' DIMENSIONING PROBLEM IN CLSS')
      RETURN
      END
      REAL*8 FUNCTION INTERP   (XX,X,F,J1,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION   X(1),F(1)
      FX=0.
      ISTART=J1-N+N/2+1
      J2=ISTART+N-1
      DO 10 J=ISTART,J2
      P=F(J)
      DO 5 I=ISTART,J2
      IF (I.EQ.J) GO TO 5
      P=P*(XX-X(I))/(X(J)-X(I))
    5 CONTINUE
   10 FX=FX+P
      INTERP=FX
      RETURN
      END
      SUBROUTINE MATS(QX1,QX2,QX3,WW,PARAM,V,MAXM1,BMAT)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION H(13,13),PARAM(51)
      DIMENSION WW(9,9),V(9,4),BMAT(4,4)
      COMMON/HTEST/ H
      YY=3.1415926536
      MAX=MAXM1+4
      SR2=SQRT(2.)
      SR3=SQRT(3.)
      A1=PARAM(1)
      A6=PARAM(2)
      A14=PARAM(3)
      A19=PARAM(4)
      P1=PARAM(5)
      P2=PARAM(6)
      P3=PARAM(7)
      P4=PARAM(8)
      P5=PARAM(9)
      P6=PARAM(10)
      P12=PARAM(11)
      P14=PARAM(12)
      P24=PARAM(13)
      P35=PARAM(14)
      B1=PARAM(15)
      B4=PARAM(16)
      B5=PARAM(17)
      B10=PARAM(18)
      B8=PARAM(19)
      B9=PARAM(20)
      B2=PARAM(21)
      B3=PARAM(22)
      B7=PARAM(23)
      B6=PARAM(24)
      C1=PARAM(25)
      C6=PARAM(26)
      C2=PARAM(27)
      CC3=PARAM(28)
      CC7=PARAM(29)
      CC8=PARAM(30)
      EE=PARAM(31)
      EE2=PARAM(32)
      E4=PARAM(33)
      E5=PARAM(34)
      D1=PARAM(35)
      D2=PARAM(36)
      D3=PARAM(37)
      D4=PARAM(38)
      D5=PARAM(39)
      D6=PARAM(40)
      D7=PARAM(41)
      D8=PARAM(42)
C   PARAMETERS OF 2ND NN A-B INTERACIONS S-P ORBITALS H-MATRIX
      F1=PARAM(43)
      PSS=PARAM(44)
      SPS=PARAM(45)
      PPS=PARAM(46)
      PPP=PARAM(47)
C   PARAMETERS OF 2ND NN A-B INTERACIONS SP-D ORBITALS H-MATRIX
      SDS=PARAM(48)
      PDS=PARAM(49)
      PDP=PARAM(50)
      B11=B9
      A2=P1
      A3=P12/SR2
      A4=SR3*P14/2.
      A5=-P14/2.
      A7=(P2+P3)/2.
      A8=P3
      A9=(P2-P3)/2.
      A10=SR3*SR2*P24/4.
      A11=P35/SR2
      A12=(SR2*SR3*P35+P24/SR2)/4.
      A13=(-SR3*P24+2.*P35)/(4.*SR2)
      A15=(3.*P4+P6)/4.
      A16=(P5+P6)/2.
      A17=(P5-P6)/2.
      A18=SR3*(P6-P4)/4.
      A20=(P4+3.*P6)/4.
      A21=P5
      C3=CC3/SR2
      C7=(CC7+CC8)/2.
      C8=CC8
      C9=(CC7-CC8)/2.
C    THREE TO TWO CENTER RELATIONSHIPS FOR 2ND NN A-B INTERACTIONS
C    OF S AND P ORBITALS.
      F2=PSS/SR3
      F3=SPS/SR3
      F4=(PPS+2.*PPP)/3.
      F5=(PPS-PPP)/3.
C   SIMILARLY INCLUDING D ORBITALS OF ATOM A
      G1=SDS/SR3
      G2=(PDS+PDP/SR3)/3.
      G3=(PDS-2.*PDP/SR3)/3.
      G4=PDS/SR3
      DO9I=1,MAX
      DO9J=1,MAX
 9       H(I,J)=0.0
      X1=YY*QX1
      Y1=YY*QX2
      Z1=YY*QX3
      COSX=COS(X1)
      COSY=COS(Y1)
      COSZ=COS(Z1)
      SINX=SIN(X1)
      SINY=SIN(Y1)
      SINZ=SIN(Z1)
      COS2X=COS(2.*X1)
      COS2Y=COS(2.*Y1)
      COS2Z=COS(2.*Z1)
      SIN2X=SIN(2.*X1)
      SIN2Y=SIN(2.*Y1)
      SIN2Z=SIN(2.*Z1)
      H(1,1)=A1+4.*A2*(COSX*COSY+COSY*COSZ+COSZ*COSX)+2.*B1*(COS2X+COS2Y
     1+COS2Z)
C
C+++++H(1,2),H(1,3),H(1,4) ARE REVERSED IN SIGN SO THAT THE REAL MATRIX
C     EQUIVALENT TO COMPLEX MATRIX
C
      H(1,2)=4.*A3*SINX*(COSY+COSZ)+2.*B2*SIN2X
      H(1,3)=4.*A3*SINY*(COSZ+COSX)+2.*B2*SIN2Y
      H(1,4)=4.*A3*SINZ*(COSX+COSY)+2.*B2*SIN2Z
      H(1,2)=-H(1,2)
      H(1,3)=-H(1,3)
      H(1,4)=-H(1,4)
      H(1,5)=-4.*A4*SINX*SINY
      H(1,6)=-4.*A4*SINY*SINZ
      H(1,7)=-4.*A4*SINZ*SINX
      H(1,8)=2.*SR3*A5*COSZ*(COSY-COSX)+SR3*B3*(COS2X-COS2Y)
      H(1,9)=-2.*A5*(-2.*COSX*COSY+COSY*COSZ+COSZ*COSX)+B3*(-COS2X-COS2Y
     1+2.*COS2Z)
      H(2,2)=A6+4.*A7*COSX*(COSY+COSZ)+4.*A8*COSY*COSZ+2.*B4*COS2X+2.*B5
     1*(COS2Y+COS2Z)
      H(2,3)=-4.*A9*SINX*SINY
      H(2,4)=-4.*A9*SINX*SINZ
      H(2,5)=4.*SINY*(A10*COSX+A11*COSZ)+2.*B6*SIN2Y
      H(2,6)=0.
      H(2,7)=4.*SINZ*(A10*COSX+A11*COSY)+2.*B6*SIN2Z
      H(2,8)=2.*SR3*A12*SINX*(COSY+COSZ)+2.*A13*SINX*(COSY-COSZ)+SR3*B7*
     1SIN2X
      H(2,9)=-2.*A12*SINX*(COSY+COSZ)+2.*SR3*A13*SINX*(COSY-COSZ)-B7*
     1SIN2X
      H(3,3)=A6+4.*A7*COSY*(COSZ+COSX)+4.*A8*COSZ*COSX+2.*B4*COS2Y+
     12.*B5*(COS2Z+COS2X)
      H(3,4)=-4.*A9*SINY*SINZ
      H(3,5)=4.*SINX*(A10*COSY+A11*COSZ)+2.*B6*SIN2X
      H(3,6)=4.*SINZ*(A10*COSY+A11*COSX)+2.*B6*SIN2Z
      H(3,7)=0.
      H(3,8)=-2.*SR3*A12*SINY*(COSZ+COSX)-2.*A13*SINY*(COSX-COSZ)-SR3*B7
     1*SIN2Y
      H(3,9)=-2.*A12*SINY*(COSZ+COSX)-2.*SR3*A13*SINY*(COSZ-COSX)-B7*
     1SIN2Y
      H(4,4)=A6+4.*A7*COSZ*(COSX+COSY)+4.*A8*COSX*COSY+2.*B4*COS2Z+2.*B5
     1*(COS2X+COS2Y)
      H(4,5)=0.
      H(4,6)=4.*SINY*(A10*COSZ+A11*COSX)+2.*B6*SIN2Y
      H(4,7)=4.*SINX*(A10*COSZ+A11*COSY)+2.*B6*SIN2X
      H(4,8)=4.*A13*SINZ*(COSY-COSX)
      H(4,9)=4.*A12*SINZ*(COSX+COSY)+2.*B7*SIN2Z
      H(5,5)=A14+4.*A15*COSX*COSY+4.*A16*COSZ*(COSX+COSY)+2.*B8*(COS2X+
     1COS2Y)+2.*B9*COS2Z
      H(5,6)=-4.*A17*SINX*SINZ
      H(5,7)=-4.*A17*SINY*SINZ
      H(5,8)=0.
      H(5,9)=-4.*A18*SINX*SINY
      H(6,6)=A14+4.*A15*COSY*COSZ+4.*A16*COSX*(COSY+COSZ)+2.*B8*(COS2Z
     1+COS2Y)+2.*B9*COS2X
      H(6,7)=-4.*A17*SINX*SINY
      H(6,8)=-2.*SR3*A18*SINY*SINZ
      H(6,9)=2.*A18*SINY*SINZ
      H(7,7)=A14+4.*A15*COSX*COSZ+4.*A16*COSY*(COSX+COSZ)+2.*B8*(COS2X+
     1COS2Z)+2.*B9*COS2Y
      H(7,8)=2.*SR3*A18*SINX*SINZ
      H(7,9)=2.*A18*SINX*SINZ
      H(8,8)=A19+3.*A20*COSZ*(COSX+COSY)+4.*A21*(COSX*COSY+COSX*COSZ/4.+
     1COSY*COSZ/4.)+(3./2.)*B10*(COS2X+COS2Y)+2.*B11*(COS2X/4.+COS2Y/4.+
     2COS2Z)
      H(8,9)=SR3*COSZ*(COSX-COSY)*(A20-A21)+(SR3/2.)*(COS2Y-COS2X)*(B10-
     1B11)
      H(9,9)=A19+4.*A20*(COSX*COSY+COSX*COSZ/4.+COSY*COSZ/4.)+3.*A21*
     1COSZ*(COSX+COSY)+2.*B10*(COS2X/4.+COS2Y/4.+COS2Z)+(3./2.)*B11*
     2(COS2X+COS2Y)
C     CHANGES TO INCORPORATE 2ND NN OF THE A-B INTERACTIONS
      H(1,10)=2.*D1*(COSX+COSY+COSZ)+8.*F1*COSX*COSY*COSZ
      H(2,10)=2.*D3*SINX+8.*F2*SINX*COSY*COSZ
      H(3,10)=2.*D3*SINY+8.*F2*SINY*COSZ*COSX
      H(4,10)=2.*D3*SINZ+8.*F2*SINZ*COSX*COSY
      H(5,10)=-8.*G1*SINX*SINY*COSZ
      H(6,10)=-8.*G1*COSX*SINY*SINZ
      H(7,10)=-8.*G1*SINX*COSY*SINZ
      H(8,10)=SR3*D7*(COSX-COSY)
      H(9,10)=D7*(-COSX-COSY+2.*COSZ)
      H(10,10) =
     1 C1+4.*C2*(COSX*COSY+COSY*COSZ+COSZ*COSX)+2.*EE*(COS2X+COS2Y
     1+COS2Z)
      H(1,11)=2*D2*SINX+8.*F3*SINX*COSY*COSZ                                                 
      H(1,12)=2*D2*SINY+8.*F3*SINY*COSZ*COSX                                                 
      H(1,13)=2*D2*SINZ+8.*F3*SINZ*COSX*COSY                                                 
      H(2,11)=2*D4*COSX+2*D5*(COSY+COSZ)+8.*F4*COSX*COSY*COSZ                                
      H(2,12)=-8.*F5*SINX*SINY*COSZ                                                       
      H(2,13)=-8.*F5*SINX*SINZ*COSY                                                       
      H(3,11)=H(2,12)                                                       
      H(3,12)=2*D4*COSY+2*D5*(COSZ+COSX)+8.*F4*COSX*COSY*COSZ                                
      H(3,13)=-8.*F5*SINY*SINZ*COSX                                                       
      H(4,11)=H(2,13)                                                       
      H(4,12)=H(3,13)                                                       
      H(4,13)=2*D4*COSZ+2*D5*(COSY+COSX)+8.*F4*COSX*COSY*COSZ                                
C   END OF 2ND NN A-B INTERACTIONS FOR S AND P ORBITALS
      H(5,11)=2.*D6*SINY+8.*G2*COSX*SINY*COSZ                                                
      H(5,12)=2.*D6*SINX+8.*G2*SINX*COSY*COSZ                                                
      H(5,13)=-8.*G3*SINX*SINY*SINZ                                                       
      H(6,11)=-8.*G3*SINX*SINY*SINZ                                                       
      H(6,12)=2.*D6*SINZ+8.*G2*COSX*COSY*SINZ                                                
      H(6,13)=2.*D6*SINY+8.*G2*COSX*SINY*COSZ                                                
      H(7,11)=2.*D6*SINZ+8.*G2*COSX*COSY*SINZ                                                
      H(7,12)=-8.*G3*SINX*SINY*SINZ                                                       
      H(7,13)=2.*D6*SINX+8.*G2*SINX*COSY*COSZ                                                
      H(8,11)=SR3*D8 *SINX+8.*G4*SINX*COSY*COSZ                                              
      H(8,12)=-SR3*D8 *SINY-8.*G4*COSX*SINY*COSZ                                             
      H(8,13)=0.0                                                       
      H(9,11)=-D8 *SINX-(8./SR3)*G4*SINX*COSY*COSZ                                                 
      H(9,12)=-D8 *SINY-(8./SR3)*G4*COSX*SINY*COSZ                                                 
      H(9,13)=2*D8 *SINZ+(16./SR3)*G4*COSX*COSY*SINZ                                                
      H(10,11)                                                          
     1     =-4.*C3*SINX*(COSY+COSZ)-2.*EE2*SIN2X                         
      H(10,12)=                                                         
     1      -4.*C3*SINY*(COSZ+COSX)-2.*EE2*SIN2Y                         
      H(10,13)=                                                         
     1      -4.*C3*SINZ*(COSX+COSY)-2.*EE2*SIN2Z                         
      H(11,11)=C6+                                                      
     1          4.*C7*COSX*(COSY+COSZ)+4.*C8*COSY*COSZ+2.*E4*COS2X+     
     22.*E5*(COS2Y+COS2Z)                                               
      H(11,12)= -C9*SINX*SINY*4.                                        
      H(11,13)= -C9*SINX*SINZ*4.                                        
      H(12,12)=C6+                                                      
     1          4.*C7*COSY*(COSZ+COSX)+4.*C8*COSZ*COSX+2.*E4*COS2Y+     
     22.*E5*(COS2Z+COS2X)                                               
      H(12,13)= -C9*SINY*SINZ*4.                                        
      H(13,13)=C6+                                                      
     1          4.*C7*COSZ*(COSX+COSY)+4.*C8*COSX*COSY+2.*E4*COS2Z+     
     22.*E5*(COS2X+COS2Y)                                               
      DO99J=1,MAX
      DO99I=1,J
 99   H(J,I)=H(I,J)
      DO8I=1,MAXM1
      DO 91 L=1,4
      LL=9+L
  91  V(I,L)=H(I,LL)
      DO 10 J=1,9
 10   WW(I,J)=H(I,J)
  8   CONTINUE
      DO 1400  L=1,4
      DO 1400  M=1,4
      LL= L+ 9
      MM= M +9
      BMAT(L,M)=H(LL,MM)
 1400 CONTINUE
      BMAT(1,1)= BMAT(1,1) - C1
      BMAT(2,2)= BMAT(2,2) - C6
      BMAT(3,3)= BMAT(3,3) - C6
      BMAT(4,4)= BMAT(4,4) - C6
      RETURN
      END
      SUBROUTINE SIMP(XX,FX,AX,NX)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XX(4000),FX(4000),AX(4000)
      DELX= XX(2) - XX(1)
      AX(1)= 0.0
      DO 10  IX=2,NX,2
      IF(NX-IX)2,3,2
   2  AX(IX)= DELX*(5.0*FX(IX-1)+8.0*FX(IX)-FX(IX+1))/12.0+AX(IX-1)
      AX(IX+1)=DELX*(FX(IX-1)+4.0*FX(IX)+FX(IX+1))/3.0+AX(IX-1)
   10 CONTINUE
      GO TO 4
    3 AX(NX)=DELX*(-FX(NX-2)+8.0*FX(NX-1)+5.0*FX(NX))/12.0+AX(NX-1)
    4 RETURN
      END
      SUBROUTINE WTFIND(MESH,IMESH)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/ADDIN/ WT,SWT
      REAL*8 SWT
      DIMENSION WT(1500)
C     FCC WEIGHTS
      KK=0
      IIW=0
      DO 20   IY=1,IMESH
      DO 20   IX=1,IY
      DO 20   IZ=1,IX
      IT= IX+IY+IZ-3
      IF(MESH*3.LT.IT) GO TO 20
      IW=48
      IF(IX.EQ.IY) IW=24
      IF(IX.EQ.IZ) IW=24
      IF(IZ.EQ.1) IW=24
      IF(IY.EQ.IZ) IW=8
      IF(IY.EQ.IX.AND.IZ.EQ.1) IW=12
      IF(IX.EQ.1) IW=6
      IF(IY.EQ.1) IW=1
      IF(MESH*3.EQ.IT) GO TO 30
      IF(IY.EQ.IMESH) GO TO 40
      GO TO 4420
   30 CONTINUE
      IW=IW/2
      IF(IZ.EQ.1) IW=IW*2/3
      IF(IY.EQ.IMESH) IW=IW*2/3
      IF(IY.EQ.IMESH.AND.IZ.EQ.1) IW=6
      GO TO 4420
   40 CONTINUE
      IW=IW/2
 4420 CONTINUE
      W=IW
      KK=KK+1
      WT(KK)=W
      IF(I.EQ.1) WT(KK)=1.0
   20 CONTINUE
C  20 WRITE(6,3) I,J,K,KK,WT(KK)
    3 FORMAT(1X,4I5,F10.5)
      SWT=0.0
      DO 25 I=1,KK
   25 SWT=SWT+WT(I)
      WRITE(6,4) SWT
    4 FORMAT(' SUM OF WEIGHTS IS',E16.7)
      RETURN
      END
